# Évolutions

## 1. Édition sur multiples enregistrements

#### Formulaire objet métier

Sur le formulaire objet métier un nouveau champ permet de spécifier si l’édition multiple
est disponible.

![image](images/multiple_1.png)

#### Studio

Dans le studio l'interface a été modifiée pour choisir un nouveau type de formulaire "Formulaire d'édition multiple".

![image](images/multiple_2.png)

#### Requêteur

Un bouton “Modifier les enregistrements” apparaîtra dans le requêteur si l’option “édition
multiple” a été sélectionnée dans la définition de l’objet métier,

![image](images/multiple_3.png)

#### Formulaire

Le formulaire permettra la mise à jour des champs spécifiés sur le formulaire spécifique.

Les valeurs nulles ne seront pas prises en compte lors de la mise à jour. Seules les
valeurs définies par l’utilisateur seront inscrites dans la base de données pour les entités
sélectionnées précédemment dans le requêteur.

Bien évidemment, le bouton « Modifier la géométrie » ne sera pas disponible à partir des
formulaires d’édition multiple

![image](images/multiple_4.png)

## 2. Optimisation édition des objets métiers non graphiques

#### Formulaire objet métier

Pour spécifier qu’un objet métier n’est pas de géométrique il suffira de en pas
remplir le champ “Colonne géométrique”.

![image](images/non_graphique_1.png)

#### Sélection sur la carte

Si un objet métier ne comporte pas de géométrie il ne sera pas disponible sur
la liste du composant “i” permettant l’accès à la donnée par intersection
ponctuelle.

![image](images/non_graphique_2.png)

#### Requêteur

Les boutons “info-bulle” ainsi que le champ “Activer / Désactiver la requête
spatiale” en seront pas présents.

![image](images/non_graphique_3.png)

#### Formulaire édition et insertion

Dans les outils d’insertion et d’édition les boutons correspondants à la modification ou a la création de géométries ne seront plus affichés.

![image](images/non_graphique_4.png)

## 3. Studio : prise en compte des valeurs du formulaire courant dans les requête de filtrage des sources de données des objets métiers

Dans les sources de données de type "Valeurs d'une table locale" il est désormais possible de créer un filtre en liant la valeur à une des valeurs du formulaire, pour cela dans l'exemple où notre champ s'appelle **route_id** il faudra écrire `={{route_id}}`

![](images/studio_1.jpg)

## 4. Studio : paramétrage d’événements

Le but de cette évolution est que l’administrateur puisse paramétrer des événements de
type onchange, onfocus, onblur, sur des champs dont le type appartient à la liste ci-
après.

* Décimal
* Entier
* Texte en édition – 1 ligne
* Texte en édition – Adresse mail
* Texte en édition – Mot de passe
* Texte en édition – Multiligne
* Texte en édition – URL
* Date
* Date et heure
* Liste
* Liste déroulante

Dans les options dynamiques un nouveau champ **Événement** sera disponible, en cliquant
sur le bouton situé sur la partie gauche du champ l’administrateur choisit le type
d’événement qu’il veut utiliser.

![image](images/events_studio_1.png)

Sur la partie droite du champ l’administrateur fournira la fonction qu’il veut voir appellée de
la même manière qu’il le fait avec les éléments de type Interface - Bouton.

![image](images/events_studio_1.png)

## 5. Nombre d’enregistrements affichés dans le requêteur

Il sera désormais possible depuis l'espace de configuration de gérer le nombre d'enregistrements visualisables dans le requêteur

![](images/ng_enregistrements_requeteur.png)

## 6. Ouverture du formulaire en édition après le formulaire d'ajout

Dans le formulaire objets métiers, une nouvelle option permet d'afficher automatiquement le formulaire d'édition après avoir ajouté un enregistrement.

Ceci est très utile lorsque on des fonctions de type trigger en base de données.

![](images/edition_auto.jpg)

## 7. Ajout de la fonction Cloner l'enregistrement

Dans le formulaire de configuration des objets métiers, une nouvelle option **Objet clonable** est disponible.

Si un objet est clonable alors dans le formulaire d'édition un bouton **Cloner** permet à l'utilisateur de cloner l'enregistrement.

Le clonage ne prend en compte que les valeurs attributaires, l'utilisateur devra renseigner une géométrie pendant l'étape.

## 8. Harmonisation des outils de sélection et édition avec les outils de mesure

Désormais lors de l'utilisation des fonctions d'édition et de sélection, seront affichées les mesures de la géométrie en cours.

![](images/harmonisation_selection.jpg)

## 9. Échelles pour l'impression liées à celles de la carte

Lorsque l'utilisateur renseigne une nouvelle échelle dans la carte, celle-ci apparaîtra également sur les outils d'impression.

![](images/echelle_impression.jpg)

## 10. Impression : garder la saisie des champs du formulaire quand on ferme puis réouvre l'outil

Désormais lorsque l'utilisateur saisie des champs dans l'outil d'impression, si il ferme ou qu'il change de modèle, sa saisie est sauvegardée.

## 11. Affichage du titre des couches par ordre alphabétique

Désormais dans le sous menu des calques les couches apparaissent par ordre alphabétique et celons leur titre.

Avant

![](images/noms_couches_1.png)

Après

![](images/noms_couches_2.png)

## 12. Légende : respecter les échelles des couches

En version 2019.01 les légendes sont fixes, elles sont demandées à Mapserver pour toutes échelles confondues. Le but de cette évolution est de pouvoir définir des légendes dynamiques qui vont se recharger lorsque le zoom est modifié sur la carte.

Pour cela dans le formulaire du calque un champ "Légende dynamique" qui permettra de recharger la légende lorsque le niveau de zoom est modifié de maniètre à afficher les légendes en fonction des seuils de visibilités des couches.

![image](images/legende_dynamique.png)

## 13. Impressions au format JPEG

Dans l'outil d'impression ajout d'ne option permettant d'imprimer au format JPEG

![](images/impression_jpeg.png)

## 14. Affichage du système [EPSG : 4326] - WGS84.LL dans le tableau des mesures

Désormais les mesures seront affichées par défaut en longitude / latitude

## 15. Ajout de la fonction déplacer la géométrie dans les outils d'insertion et modification

Un nouveau bouton déplacer la géométrie est disponible pour les géométries de type ligne et polygone.

![](images/deplacer_geom.jpg)

## 16. Gestion des objets superposés

Lors d'une sélection simple, si plusieurs objets se superposent alors un menu permettant de lister la sélection apparaît.

![](images/objets_superposés.jpg)

Attention cette fonctionnalité disponible uniquement si le nombre maximal de popups est supérieur à 1.

![](images/objets_superposés_1.jpg)

## 17. Paramétrage des échelles disponibles dans l'application

Dans le menu configuration de vMap il est désormais possible de configurer la liste des échelles proposées par défaut dans le mode cartographie.

## 18. Outil de localisation : Pouvoir inverser OSM et Base Nationale avec les objets métiers

Une nouvelle option permet de choisir le geocodeur par défaut de l'outil de localisation.

Mode vMap :

![](images/inverser_osm_1.png)

Mode configuration :

![](images/inverser_osm_2.png)

## 19. Impression : choix de l'ordre d'affichage des modèles depuis l'interface d'administration

une option permet désormais de choisir l'ordre dans lequel apparaissent les modèles d'impression, si aucune valeur n'est saisie alors ils seront triés par ordre alphabétique.

![](images/ordre_impressions.jpg)

## 20. Impression : ajouter un bouton utiliser l'étendue en cours

Au niveau du formulaire d’impression, un bouton « Conserver l’étendue visible » permet que afin que la totalité du plan visible à l’écran soit imprimé.

Ceci entraînera bien évidemment l’adaptation de l’échelle d’impression pour faire entrer la totalité du plan dans la page correspondant au modèle choisi.

![](images/impression_jpeg.png)

## 21. Permettre de choisir si les couches d'un calque sont affichés par défaut

Dans le formualire du calque l'administrateur pourra sélectionner les couches du calque affichées par défaut.

![](images/selection_couches_actives.jpg)

## 22. Mapserver

* Passage à la version 7.3.6

# Anomalies corrigées

#### Chargement de la liste calques de la carte trop long

Lorsqu'on ajoute des calques à la carte le chargement se fait très long si l'administrateur possède de nombreux calques.

#### Grilles objet métier : problèmes de cache

Après avoir interrogé un premier enregistrement affichant une grille objet métier, parfois en interrogeant un second enregistrement la grille de ce dernier correspond à celle du premier comme si le résultat avait été gardé en caches

#### Upload de fichiers : erreur sur l'utilisation des documents

* Certains fichiers ne s'uploadent pas en mode document
* Les images passées en tant que document ne devraient pas être compressées
* Erreur en mode grille - objet métier

#### Ouverture automatique fenêtre GetFeatureInfo au démarrage de l'application mobile.

#### Impossible de se connecter en passant le login/mp dans l'URL

#### Saisie impossible dans les formulaires pour les attributs de type carte vMap

Dans un objet métier au niveau d'un formulaire ayant pour définition un champ carte vMap, il y a un problème de saisie impossible de geometrie, au niveau du studio ou du formulaire en édition.

#### ANC : Compte postgres utilisé comme owner

Le compte postgres est utilisé comme owner dans s_anc empêchant ainsi l'utilisation de vMap sur base de données RDS

#### Mettre le mail utilisé dans l'oubli de mot de passe sur une propertie

![](images/pb_mpd_boubli.jpeg)

#### Studio : Problème d'identifiants dupliqués

Le studio remplit automatiquement des identifiants aléatoires, parfois ces deniers peuvent être dupliqués avec d'autres formulaires posant ainsi certains problèmes JS

#### Affichage du bouton du suppression dans un champ de type document en mode consultation uniquement

#### Fiche d'urbanisme : problème d'affichage lorsque le nombre d'intersections est trop grand

#### ANC : Doublons sur les installations

Lorsque une installation se compose de plusieurs contrôles dont les attributs cl_avis ou classement diffèrent, des doublons apparaissent dans la vue v_installation

#### Bouton "Gestion des carte" non affiché sur écran a faible définition verticale

#### Erreur lors de l'utilisation d'entiers supérieurs à 20140331124021456160 dans les valeurs des listes déroulantes

#### Encodage fichier issue de l'export depuis Requeteur

Lorsqu'on exporte le résultat du requêteur les caractères spéciaux sont encodés en xml. Export excel testé et csv.

Depuis le panier pas de problème.

#### Liste double problème lorsque la valeur requise

#### Studio : erreur utilisation grille section vitis

#### Aucun message d'erreur lorsque la clé recaptcha est mauvaise

Lors de la création d'un compte par un utilisateur de manière automatique, si la clé recaptcha est mauvaise l'utilisateur reçoit une notification disant qu'il va recevoir un mail de confirmation ors celui-ci n'arrive jamais.
